{ Demo Select Object  Nicholas G. Lordi  Nov. 2011

  This object enables selection of a S2 demo from a PC terminal
  emulator.  It runs continuously in its own cog, allowing the
  user to change the demo choice while the demo is running.  The
  current demo will finish before a newly selected demo executes. 

}

CON

 '' XBee  Parameters
  XB_Rx    = 0
  XB_Tx    = 1
  XB_Baud  = 9600



  
VAR

  byte cog
  long Stack[100], selDemo

OBJ

  xb  : "XBee_Object"   

PUB  Start(addrSelDemo)   : result

  xb.start(XB_Rx, XB_Tx, 0, XB_Baud)
  xb.rxFlush 
  Stop       
  cog := cognew(getSelCmd(addrSelDemo), @Stack) + 1
  result := cog

PUB Stop

    if cog
      cogstop(cog~ -1)

PUB getSelCmd(addrSelDemo) 

   'Branch to a demo program 
  xb.str(string("0: light sensor    1: light follow"))
  xb.CR
  xb.str(string("2: obstacle sensor 3: obstacle avoid"))
  xb.CR                                                                                
  xb.str(string("4: line sensor     5: line follow"))
  xb.CR
  xb.str(string("6: drawing         7: ambulance"))
  Xb.Cr
  xb.str(string("8: stop            9: reset" ))
  xb.CR
  xb.str(string(" Enter Demo Choice..."))
  xb.CR   
  repeat until selDemo > 8
    
    selDemo := xb.RxDec
    xb.Delay(100)
    long[addrSelDemo] := selDemo
    xb.str(string("Next Choice?.."))
        

       